<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/tree.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/functions.inc.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/cache/config.php');

$mh = new MessageHandler;
$mytree = new ArticlesTree($db->prefix("arttopics"), "topic_id", "topic_pid");

$tables = array('artstories', 'arttopics', 'artcomments', 'artvotedata');
$files = array('include/functions/add_topic.php',
'class/class.newsstory.php',
'class/news.textsanitizer.php',
'class/newstopic.php',
'class/newstree.php',
'include/functions/news_config.php',
'cache/config.php',
'blocks/news_bigstory.php',
'blocks/news_comments.php',
'blocks/news_top.php',
'include/functions/showListArticles.php',
'include/functions/showSectionsClassic.php',
'include/functions/showSectionsTree.php');

$sql[0] = "ALTER TABLE " . $db->prefix("artstories") . " CHANGE COLUMN title title varchar(255) NOT NULL";
$sql[1] = "ALTER TABLE " . $db->prefix("artstories") . " ADD COLUMN rating float(3,2) unsigned NOT NULL DEFAULT '0.00' AFTER topicalign";
$sql[2] = "ALTER TABLE " . $db->prefix("artstories") . " ADD COLUMN votes smallint(5) unsigned NOT NULL DEFAULT '0' AFTER rating";
$sql[3] = "CREATE TABLE " . $db->prefix("artvotedata") . " (
  ratingid mediumint(8) unsigned NOT NULL auto_increment,
  lid mediumint(8) unsigned NOT NULL default '0',
  ratinguser mediumint(8) unsigned NOT NULL default '0',
  rating float(4,2) unsigned NOT NULL default '0.00',
  ratinghostname char(15) NOT NULL default '',
  ratingtimestamp int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (ratingid),
  KEY idx (lid)
) TYPE=MyISAM";
$sql[4] = "ALTER TABLE " . $db->prefix("artstories") . " ADD comments smallint(5) unsigned NOT NULL default '0'";
$sql[5] = "ALTER TABLE " . $db->prefix("arttopics") . " ADD items SMALLINT(5)  UNSIGNED NOT NULL AFTER topic_desc";
$sql[6] = "ALTER TABLE " . $db->prefix("artstories") . " ADD use_wysiwyg tinyint(1) unsigned NOT NULL DEFAULT '0'";
$sql[7] = "ALTER TABLE " . $db->prefix("arttopics") . " ADD INDEX idx (topic_pid,topic_id), DROP INDEX idx";
$sql[8] = "ALTER TABLE " . $db->prefix("artstories") . " CHANGE hometext hometext longtext NOT NULL";
$sql[9] = "ALTER TABLE " . $db->prefix("artstories") . " CHANGE bodytext bodytext longtext NULL";

$count = count($sql);
for ($i = 0; $i < $count; $i++) {
    if ($db->query($sql[$i])) {
        $mh->setMessage($message[$i]['noerror']);
    } else {
        $mh->setErrors($message[$i]['error']);
    }
}

updateComments();
updateTopics();
_save_config();
update_status_article();
optimizeTable($tables);
delFileArray($files);
cacheTreeSelBox();

echo "<hr>";
echo "<h3>" . _UPGRADE_CONGRAT . "<font color='#FF0000'> \"_update\" </font></h3>";
_OpenTable_();
echo $mh->getErrors();
_CloseTable_();
echo "<br />";
_OpenTable_();
echo $mh->getMessage();
_CloseTable_();
echo "<br /><hr>";

function updateTopics()
{
    global $db, $mh, $mytree;

    $query = "SELECT topic_id FROM " . $db->prefix("arttopics") . " WHERE topic_pid=0";
    if ($result = $db->query($query)) {
        while (list($topic_id) = $db->fetch_row($result)) {
            _updatItems($topic_id);
            $arr = $mytree->getChildTreeArray($topic_id);
            foreach ($arr as $option) {
                _updatItems($option[$mytree->cid]);
            }
        }
    } else {
        $mh->setErrors(_NO_UPDATE_DATA_ARTS);
    }
}

function updateComments()
{
    global $db, $mh;

    if ($result = $db->query("SELECT DISTINCT item_id FROM " . $db->prefix("artcomments") . "")) {
        while ($myrow = $db->fetch_array($result)) {
            if ($result2 = $db->query("SELECT COUNT(*) FROM " . $db->prefix("artcomments") . " WHERE item_id=" . $myrow['item_id'] . "")) {
                list($count) = $db->fetch_row($result2);
                $query = "UPDATE " . $db->prefix("artstories") . " SET comments=" . $count . " WHERE storyid=" . $myrow['item_id'] . "";
                if ($db->query($query)) {
                    $mh->setMessage(sprintf(_UPDATE_COMMENT, $myrow['item_id']));
                } else {
                    $mh->setErrors(sprintf(_NO_UPDATE_COMMENT, $myrow['item_id']));
                }
            } else {
                $mh->setErrors(sprintf(_NO_CAL_COMMENTS, $myrow['item_id']));
            }
        }
    } else {
        $mh->setErrors(_NO_UPDATE_COMMENTS);
    }
}

function _updatItems($cid)
{
    global $db, $mh;
    $items = _getTotalItems($cid);
    $query = "UPDATE " . $db->prefix("arttopics") . " SET items=$items WHERE topic_id = $cid";
    if ($db->query($query)) {
        $mh->setMessage(sprintf(_UPDATE_DATA_ART, $cid));
    } else {
        $mh->setErrors(sprintf(_NO_UPDATE_DATA_ART, $cid));
    }
}

function _getTotalItems($sel_id)
{
    global $db, $mytree, $mh;
    $query = 'SELECT SUM(topicid=' . intval($sel_id) . ')';
    $arr = array();
    $arr = $mytree->getAllChildId($sel_id, 'topic_title');
    $size = count($arr);
    for ($i = 0; $i < $size; $i++) {
        $query .= ', SUM(topicid=' . intval($arr[$i]) . ')';
    }

    $query .= ' FROM ' . $db->prefix('artstories') . '';
    $query .= ' WHERE published > 0 AND published <= ' . time() . '';

    if ($result = $db->query($query)) {
        $count = $db->fetch_row($result);
        if (!empty($count)) {
            foreach ($count as $key => $value) {
                $out += $value;
            }
        }
    } else {
        $mh->setErrors(sprintf(_NO_CAL_ART, $sel_id));
    }

    return $out;
}

function _save_config()
{
    global $newsConfig, $mh;

    if (!empty($newsConfig)) {
        $newsConfig['ratearticles'] = 1;
        $newsConfig['quickreply'] = 1;
        $newsConfig['showcomments'] = 1;
        $newsConfig['hometext'] = 1;
        $newsConfig['storylist'] = 10;
        $newsConfig['wysiwyg_groups'] = "1 2";
        $newsConfig['wysiwyg_upload_allowed'] = "1 2";
        $newsConfig['rewrite_engine'] = 0;

        $content .= "[articles_config]\r\n\r\n";
        $content .= "anonsubmit = " . intval($newsConfig['anonsubmit']) . "\r\n";
        $content .= "default_toolbars = \"" . $newsConfig['default_toolbars'] . "\"\r\n";
        $content .= "default_theme = \"" . $newsConfig['default_theme'] . "\"\r\n";
        $content .= "default_lang = \"" . $newsConfig['default_lang'] . "\"\r\n";
        $content .= "storyhome = " . intval($newsConfig['storyhome']) . "\r\n";
        $content .= "storylist = " . intval($newsConfig['storylist']) . "\r\n";
        $content .= "notifysubmit = " . intval($newsConfig['notifysubmit']) . "\r\n";
        $content .= "WYSIWYGsubmit = " . intval($newsConfig['WYSIWYGsubmit']) . "\r\n";
        $content .= "wysiwyg_groups = \"" . $newsConfig['wysiwyg_groups'] . "\"\r\n";
        $content .= "wysiwyg_upload_allowed = \"" . $newsConfig['wysiwyg_upload_allowed'] . "\"\r\n";
        $content .= "ratearticles = " . intval($newsConfig['ratearticles']) . "\r\n";
        $content .= "showcomments = " . intval($newsConfig['showcomments']) . "\r\n";
        $content .= "quickreply = " . intval($newsConfig['quickreply']) . "\r\n";
        $content .= "docsubmit = " . intval($newsConfig['docsubmit']) . "\r\n";
        $content .= "topicssubmit = " . intval($newsConfig['topicssubmit']) . "\r\n";
        $content .= "listsubmit = " . intval($newsConfig['listsubmit']) . "\r\n";
        $content .= "relatedlinks = " . intval($newsConfig['relatedlinks']) . "\r\n";
        $content .= "hometext = " . intval($newsConfig['hometext']) . "\r\n";
        $content .= "displaynav = " . intval($newsConfig['displaynav']) . "\r\n";
        $content .= "rewrite_engine = " . intval($newsConfig['rewrite_engine']) . "\r\n";
        $content .= "rss_enable = " . intval($newsConfig['rss_enable']) . "\r\n";
        $content .= "rss_maxitems = " . intval($newsConfig['rss_maxitems']) . "\n";
        $content .= "rss_maxdescription = " . intval($newsConfig['rss_maxdescription']) . "\r\n";
        $content .= "show_disclaimer = " . intval($newsConfig['show_disclaimer']) . "\r\n";

        $filename = XOOPS_ROOT_PATH . "/modules/myarticles/cache/config.ini";

        if ($file = fopen($filename, "w")) {
            fwrite($file, $content);
            fclose($file);
            $mh->setMessage(_SAVE_CONFIG);
        } else {
            $mh->setErrors(_NO_SAVE_CONFIG);
        }
    } else {
        $mh->setErrors(_NO_SAVE_CONFIG);
    }
}

?>
