<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/tree.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/functions.inc.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/cache/config.php');

$mh = new MessageHandler;
$mytree = new ArticlesTree($db->prefix("arttopics"), "topic_id", "topic_pid");

$tables = array('artstories', 'arttopics', 'artcomments', 'artvotedata');
$files = array('class/artform.php',
'class/class.newsstory.php',
'class/cp_cattree.php',
'class/formheadingrow.php',
'class/formImgtext.php',
'class/news.textsanitizer.php',
'class/newstopic.php',
'class/newstree.php',
'include/functions/news_config.php',
'cache/config.php',
'blocks/news_bigstory.php',
'blocks/news_comments.php',
'blocks/news_top.php',
'include/functions/showListArticles.php',
'include/functions/showSectionsClassic.php',
'include/functions/showSectionsTree.php');

$sql[0] = "ALTER TABLE " . $db->prefix("artstories") . " ADD use_wysiwyg tinyint(1) unsigned NOT NULL DEFAULT '0'";
$sql[1] = "ALTER TABLE " . $db->prefix("arttopics") . " ADD INDEX idx (topic_pid,topic_id), DROP INDEX idx";
$sql[2] = "ALTER TABLE " . $db->prefix("artstories") . " CHANGE hometext hometext longtext NOT NULL";
$sql[3] = "ALTER TABLE " . $db->prefix("artstories") . " CHANGE bodytext bodytext longtext NULL";

$count = count($sql);
for ($i = 0; $i < $count; $i++) {
    if ($db->query($sql[$i])) {
        $mh->setMessage($message[$i]['noerror']);
    } else {
        $mh->setErrors($message[$i]['error']);
    }
}

_save_config();
update_status_article();
optimizeTable($tables);
delFileArray($files);
cacheTreeSelBox();

echo "<hr>";
echo "<h3>" . _UPGRADE_CONGRAT . "<font color='#FF0000'> \"_update\" </font></h3>";
_OpenTable_();
echo $mh->getErrors();
_CloseTable_();
echo "<br />";
_OpenTable_();
echo $mh->getMessage();
_CloseTable_();
echo "<br /><hr>";

function _save_config()
{
    global $newsConfig, $mh;

    if (!empty($newsConfig)) {
        $newsConfig['ratearticles'] = 1;
        $newsConfig['quickreply'] = 1;
        $newsConfig['wysiwyg_groups'] = "1 2";
        $newsConfig['wysiwyg_upload_allowed'] = "1 2";
        $newsConfig['rewrite_engine'] = 0;

        $content .= "[articles_config]\r\n\r\n";
        $content .= "anonsubmit = " . intval($newsConfig['anonsubmit']) . "\r\n";
        $content .= "default_toolbars = \"" . $newsConfig['default_toolbars'] . "\"\r\n";
        $content .= "default_theme = \"" . $newsConfig['default_theme'] . "\"\r\n";
        $content .= "default_lang = \"" . $newsConfig['default_lang'] . "\"\r\n";
        $content .= "storyhome = " . intval($newsConfig['storyhome']) . "\r\n";
        $content .= "storylist = " . intval($newsConfig['storylist']) . "\r\n";
        $content .= "notifysubmit = " . intval($newsConfig['notifysubmit']) . "\r\n";
        $content .= "WYSIWYGsubmit = " . intval($newsConfig['WYSIWYGsubmit']) . "\r\n";
        $content .= "wysiwyg_groups = \"" . $newsConfig['wysiwyg_groups'] . "\"\r\n";
        $content .= "wysiwyg_upload_allowed = \"" . $newsConfig['wysiwyg_upload_allowed'] . "\"\r\n";
        $content .= "ratearticles = " . intval($newsConfig['ratearticles']) . "\r\n";
        $content .= "showcomments = " . intval($newsConfig['showcomments']) . "\r\n";
        $content .= "quickreply = " . intval($newsConfig['quickreply']) . "\r\n";
        $content .= "docsubmit = " . intval($newsConfig['docsubmit']) . "\r\n";
        $content .= "topicssubmit = " . intval($newsConfig['topicssubmit']) . "\r\n";
        $content .= "listsubmit = " . intval($newsConfig['listsubmit']) . "\r\n";
        $content .= "relatedlinks = " . intval($newsConfig['relatedlinks']) . "\r\n";
        $content .= "hometext = " . intval($newsConfig['hometext']) . "\r\n";
        $content .= "displaynav = " . intval($newsConfig['displaynav']) . "\r\n";
        $content .= "rewrite_engine = " . intval($newsConfig['rewrite_engine']) . "\r\n";
        $content .= "rss_enable = " . intval($newsConfig['rss_enable']) . "\r\n";
        $content .= "rss_maxitems = " . intval($newsConfig['rss_maxitems']) . "\n";
        $content .= "rss_maxdescription = " . intval($newsConfig['rss_maxdescription']) . "\r\n";
        $content .= "show_disclaimer = " . intval($newsConfig['show_disclaimer']) . "\r\n";

        $filename = XOOPS_ROOT_PATH . "/modules/myarticles/cache/config.ini";

        if ($file = fopen($filename, "w")) {
            fwrite($file, $content);
            fclose($file);
            $mh->setMessage(_SAVE_CONFIG);
        } else {
            $mh->setErrors(_NO_SAVE_CONFIG);
        }
    } else {
        $mh->setErrors(_NO_SAVE_CONFIG);
    }
}

?>
