<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 The E-Xoops/RUNCMS Project <http://www.runcms.org> 
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 * @author The E-Xoops/RUNCMS Project
 * @license GPL <http://www.gnu.org/licenses/gpl.html>
 */
include_once('./header.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/themes/theme.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/articles.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/functions.inc.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/textsanitizer.class.php');

$item_id = (!empty($_GET['item_id'])) ? intval($_GET['item_id']) : 0;
$storyid = (!empty($_GET['storyid'])) ? intval($_GET['storyid']) : 0;
$comment_id = (!empty($_GET['comment_id'])) ? intval($_GET['comment_id']) : 0;
$storypage = (!empty($_GET['storypage'])) ? intval($_GET['storypage']) : 0;

if (empty($storyid) && empty($item_id)) {
    redirect_header("index.php", 2, _NW_NOSTORY);
    exit();
} 
$myts = new ArtTextSanitizer();
$item_id = (!empty($storyid)) ? $storyid : $item_id;
// set comment mode if not set
if ($artConfig['showcomments'] == 1) {
    include_once(XOOPS_ROOT_PATH . "/class/xoopscomments.php");
    $mode = ($_GET['mode']) ? $myts->oopsHtmlSpecialChars(trim($_GET['mode'])) : 0;
    if (empty($mode)) {
        $mode = ($xoopsUser) ? $xoopsUser->getVar("umode"): $xoopsConfig['com_mode'];
    } 
    // set comment order if not set
    if (empty($_GET['order'])) {
        $order = ($xoopsUser) ? $xoopsUser->getVar("uorder") : $xoopsConfig['com_order'];
    } else {
        $order = intval($_GET['order']);
    } 

    $artcomment = new XoopsComments($db->prefix("artcomments"), $comment_id);
    $artcomment->setVar("item_id", $item_id);
} 

$comment_pid = is_object($artcomment) ? $artcomment->getVar("pid") : 0;

if ($comment_pid == 0) {
    $story = new Articles($item_id);
    if ($story->getVar('published') == 0 || $story->getVar('published') > time()) {
        redirect_header("index.php", 2, _NW_NOSTORY);
        exit();
    } 
    include_once(XOOPS_ROOT_PATH . "/header.php");

    $datetime = formatTimestamp($story->getVar('published'));
    $title = $story->getVar('title');
    $section = $story->textlink();
    $hometext = $story->getVar('hometext');
    $bodytext = trim($story->getVar('bodytext'));
    $ratelink = $story->ratelink();
    $uname = $story->uname();
    $counter = $story->getVar('counter');

    if (empty($bodytext)) {
        $bodytext = $hometext;
    } else {
        $content = explode("[pagebreak]", $bodytext);
        $story_pages = count($content);
        if ($story_pages > 1) {
            if ($storypage > $story_pages) $storypage = $story_pages;
            include_once(XOOPS_ROOT_PATH . '/class/xoopspagenav.php');
            $nav = new XoopsPageNav($story_pages, 1, $storypage, "storypage", "storyid=$item_id");
            $pagenav = $nav->renderNav();
            if ($storypage > 0) {
                $bodytext = trim($content[$storypage]);
            } else {
                if ($artConfig['hometext'] == 1) {
                    $bodytext = $hometext . '<br><br>';
                    $bodytext .= trim($content[0]);
                } else {
                    $bodytext = trim($content[0]);
                } 
            } 
        } else {
            if ($artConfig['hometext'] == 1) {
                $bodytext = $hometext . '<br><br>';
                $bodytext .= trim($content[0]);
            } else {
                $bodytext = trim($content[0]);
            } 
        } 
    } 

    $adminlink = "&nbsp;";
    $imglink = "";

    if (_IS_ADMIN === 1) $adminlink = $story->adminlink();
    if ($story->getVar('topicdisplay'))$imglink = $story->imglink();

    if (_IS_ADMIN === 0 && $storypage == 0 && empty($_COOKIE["storyread"][$item_id])) {
        $story->updateCounter();
        cookie("storyread[$item_id]", 1, 31536000);
    } 

    art_article($uname, $datetime, $title, $counter, $bodytext, $imglink, $adminlink, $pagenav, $ratelink, $section);

    if ($artConfig['ratearticles'] == 1) {
        include_once(XOOPS_ROOT_PATH . '/modules/myarticles/themes/ratearticles.php');
        rate_articles($item_id);
    } 
    if ($artConfig['relatedlinks'] == 1) inc_function('get_block_links', array($item_id));
} else {
    include_once(XOOPS_ROOT_PATH . "/header.php");
} 

if ($artConfig['showcomments'] == 1) {
    include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/viewcomment.inc.php');

    if ($artConfig['quickreply'] == 1 && is_object($story)) {
        if (is_object($xoopsUser) || (!is_object($xoopsUser) && $xoopsConfig['anonpost'])) {
            $subject = $story->getVar("title", "E");
            include_once(XOOPS_ROOT_PATH . "/modules/myarticles/include/quickreplyform.inc.php");
        } 
    } 
} 

inc_function('show_copyright');

include_once(XOOPS_ROOT_PATH . "/footer.php");

?>