<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

include_once("artobject.class.php");

class Articles extends ArtObject {
	function Articles($id = null)
	{
		parent::ArtObject();
		$this->initVar("storyid", "int", null, false);
		$this->initVar("uid", "int", null, true);
		$this->initVar("title", "textbox", null, true, 255, true);
		$this->initVar("created", "int", null, true);
		$this->initVar("published", "int", 0, false);
		$this->initVar("hostname", "textbox", null, true, 15, true);
		$this->initVar("allow_html", "int", 0, false);
		$this->initVar("allow_smileys", "int", 0, false);
		$this->initVar("allow_bbcode", "int", 1, false);
		$this->initVar("hometext", "textarea", null, true, null, true);
		$this->initVar("bodytext", "textarea", null, true, null, true);
		$this->initVar("counter", "int", null, true);
		$this->initVar("topicid", "int", null, true);
		$this->initVar("ihome", "int", 0, false);
		$this->initVar("notifypub", "int", 0, false);
		$this->initVar("type", "other", "admin", false);
		$this->initVar("topicdisplay", "int", 1, false);
		$this->initVar("topicalign", "other", "left", false);
		$this->initVar("rating", "other", 0.00, false);
		$this->initVar("votes", "int", null, true);
		$this->initVar("comments", "int", null, true);
		$this->initVar("uname", "textbox", null, false, null, false);
		$this->initVar("topic_id", "int", null, true);
		$this->initVar("topic_title", "textbox", null, true, 60, true);
		$this->initVar("topic_imgurl", "textbox", null, true, 255, true);
		$this->initVar("use_wysiwyg", "int", 0, false);

		if (!empty($id)) {
			if (is_array($id)) {
				$this->set($id);
			} else {
				$this->load(intval($id));
			}
		}
	}

	function load($storyid)
	{
		global $db;

		$sql = "SELECT a.*, b.uname, c.topic_id, c.topic_title, c.topic_imgurl FROM " . $db->prefix("users") . " b RIGHT JOIN " . $db->prefix("artstories") . " a ON  a.uid =b.uid LEFT JOIN  " . $db->prefix("arttopics") . " c ON a.topicid =c.topic_id WHERE a.storyid=" . $storyid . "";
		$myrow = $db->fetch_array($db->query($sql));
		$this->set($myrow);
	}

	function delete()
	{
		global $db;

		$sql = "DELETE FROM " . $db->prefix("artstories") . " WHERE storyid=" . $this->getVar("storyid");
		if (!$result = $db->query($sql)) {
			$this->setErrors("Could not delete data in database: " . $db->error());
			return false;
		}
		$this->_deleteComments();
		$this->_deleteRatings();
		return true;
	}

	function _deleteComments()
	{
		global $db;

		include_once(XOOPS_ROOT_PATH . "/class/xoopscomments.php");
		$commentsarray = array();
		$com = new XoopsComments($db->prefix("artcomments"));
		$criteria = array("item_id=" . $this->getVar("storyid"), "pid=0");
		$commentsarray = $com->getAllComments($criteria);
		foreach($commentsarray as $comment) {
			$comment->delete();
		}
	}

	function _deleteRatings()
	{
		include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/rating.class.php');
		RatingArticles::deleteByStoriesId($this->getVar("storyid"));
	}

	function &getAllArticles($criteria = array(), $limit = 0, $start = 0, $orderby = 'published DESC', $only_s = false, $asobject = true)
	{
		global $db, $myts;

		if (!empty($only_s)) {
			$sql = "SELECT * FROM " . $db->prefix("artstories") . " ";
			$prefix = "";
		} else {
			$sql = "SELECT a.*, b.uname, c.* FROM " . $db->prefix("artstories") . " a LEFT JOIN " . $db->prefix("arttopics") . " c ON a.topicid =c.topic_id LEFT JOIN " . $db->prefix("users") . " b ON  a.uid =b.uid ";
			$prefix = "a.";
		}

		$where_query = "";
		if (is_array($criteria) && count($criteria) > 0) {
			$where_query = " WHERE";
			foreach ($criteria as $c) {
				$where_query .= " " . $prefix . $c . " AND";
			}
			$where_query = substr($where_query, 0, -4);
		}

		$sql .= " " . $where_query . " ORDER BY " . $prefix . $orderby;
		$result = $db->query($sql, intval($limit), intval($start));
		while ($myrow = $db->fetch_array($result)) {
			if ($asobject) {
				$ret[] = new Articles($myrow);
			} else {
				$ret[$myrow['storyid']] = $myts->makeTboxData4Show($myrow['title']);
			}
		}
		return $ret;
	}

	function countByTopic($topicid = 0)
	{
		global $db;

		$sql = "SELECT COUNT(*) FROM " . $db->prefix("artstories") . " WHERE ";

		if ($topicid != 0) {
			$sql .= "topicid=" . intval($topicid) . " and";
		}
		$sql .= " published > 0 AND published <= " . time();
		$result = $db->query($sql);
		list($count) = $db->fetch_row($result);

		return $count;
	}

	function store()
	{
		global $myts, $db;

		if (!$this->isCleaned()) {
			if (!$this->cleanVars()) {
				return false;
			}
		}
		foreach ($this->cleanVars as $k => $v) {
			$$k = $v;
		}

		if (empty($storyid)) {
			$artstoryid = $db->genId($db->prefix("artstories") . "_storyid_seq");
			$sql = "INSERT INTO " . $db->prefix("artstories") . " SET
					storyid=" . $artstoryid . ",
					uid=" . $uid . ",
					title='" . $title . "',
					created=" . time() . ",
					published=" . $published . ",
					hostname='" . $hostname . "',
					allow_html=" . $allow_html . ",
					allow_smileys=" . $allow_smileys . ",
					allow_bbcode=" . $allow_bbcode . ",
					hometext='" . $hometext . "',
					bodytext='" . $bodytext . "',
					counter=0,
					topicid=" . $topicid . ",
					ihome=" . $ihome . ",
					notifypub=" . $notifypub . ",
					type='" . $type . "',
					topicdisplay=" . $topicdisplay . ",
					topicalign='" . $topicalign . "',
					use_wysiwyg=" . $use_wysiwyg . "";
		} else {
			$sql = "UPDATE " . $db->prefix("artstories") . " SET
					title='" . $title . "',
					published=" . $published . ",
					allow_html=" . $allow_html . ",
					allow_smileys=" . $allow_smileys . ",
					allow_bbcode=" . $allow_bbcode . ",
					hometext='" . $hometext . "',
					bodytext='" . $bodytext . "',
					topicid=" . $topicid . ",
					ihome=" . $ihome . ",
					type='" . $type . "',
					topicdisplay=" . $topicdisplay . ",
					topicalign='" . $topicalign . "',
					use_wysiwyg=" . $use_wysiwyg . "
					WHERE storyid=" . $storyid . "";
		}

		if (!$result = $db->query($sql)) {
			$this->setErrors("Could not store data in database: " . $db->error());
			return false;
		}
		if (empty($storyid)) {
			$storyid = $db->insert_id();
		}
		return $storyid;
	}

	function updateCounter()
	{
		global $db;

		$sql = "UPDATE " . $db->prefix("artstories") . " SET counter=counter+1 WHERE storyid=" . $this->getVar('storyid') . "";

		if (!$result = $db->query($sql)) {
			$this->setErrors("Could not update data in database: " . $db->error());
			return false;
		}
		return true;
	}

	function adminlink()
	{
		return "&nbsp;[ <a href='" . XOOPS_URL . "/modules/myarticles/admin/index.php?op=edit&amp;storyid=" . $this->getVar('storyid') . "'>" . _EDIT . "</a> | <a href='" . XOOPS_URL . "/modules/myarticles/admin/index.php?op=delete&amp;storyid=" . $this->getVar('storyid') . "'>" . _DELETE . "</a> ]&nbsp;";
	}
	function imglink()
	{
		if ($this->getVar('topic_imgurl')) {
			return "<a href='" . XOOPS_URL . "/modules/myarticles/index.php?storytopic=" . $this->getVar('topic_id') . "'><img src='" . formatURL(XOOPS_URL . "/modules/myarticles/cache/topics/", $this->getVar('topic_imgurl')) . "' alt='" . $this->getVar('topic_title') . "' hspace='10' vspace='10' align='" . $this->getVar('topicalign') . "' /></a>";
		} else {
			return "";
		}
	}
	function textlink()
	{
		return "<a href='" . rewrite_link(XOOPS_URL . "/modules/myarticles/index.php?topic_id=" . $this->getVar('topic_id')) . "'>" . $this->getVar('topic_title') . "</a>";
	}
	function ratelink()
	{
		return "" . _NW_RATING . ": <b>" . $this->getVar('rating') . "</b> (" . $this->getVar('votes') . ") <a href='" . rewrite_link(XOOPS_URL . "/modules/myarticles/ratearticles.php?lid=" . $this->getVar('storyid')) . "'>" . _NW_RATETHISFILE . "</a>";
	}

	function uname()
	{
		global $xoopsConfig, $myts;

		if ($this->getVar("uname", "N")) {
			return "<a href='" . XOOPS_URL . "/userinfo.php?uid=" . $this->getVar("uid") . "'>" . $this->getVar("uname") . "</a>";
		} else {
			return $myts->makeTboxData4Show($xoopsConfig['anonymous']);
		}
	}
	// ---------------------------------------------------------------------------------------//
} // END

?>