<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Vladislav Balnov (LARK)                  |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

class RcCalendar {
    var $day;
    var $time;
    var $year;
    var $table;
    var $title;
    var $month;
    var $separator;
    var $timeoffset;
    var $nextlinkdate;
    var $usertimevent;
    var $lastlinkdate;
    var $content = array();
    var $xoopsmodule = "myarticles";
    var $monthname = array('', _CALJAN, _CALFEB, _CALMAR, _CALAPR, _CALMAY,
        _CALJUN, _CALJUL, _CALAUG, _CALSEP, _CALOCT, _CALNOV, _CALDEC);
    var $weekname = array('', _NCB_1DAY, _NCB_2DAY, _NCB_3DAY, _NCB_4DAY, _NCB_5DAY,
        _NCB_6DAY, _NCB_7DAY);

    function RcCalendar($table, $title, $time)
    {
        $this->table = $table;
        $this->title = $title;
        $this->time = $time;
    } 

    function setTimeoffset()
    {
        global $xoopsConfig, $xoopsUser;

        $useroffset = "";
        if ($xoopsUser) {
            $timezone = $xoopsUser->timezone();
            if (isset($timezone)) {
                $useroffset = $xoopsUser->timezone();
            } else {
                $useroffset = $xoopsConfig['default_TZ'];
            } 
        } 

        $this->timeoffset = $useroffset - $xoopsConfig['server_TZ'];
        $this->usertimevent = time() + ($this->timeoffset * 3600);
        return true;
    } 

    function getLink($day)
    {
        $link = XOOPS_URL . "/modules/" . $this->xoopsmodule . "/index.php?t=" . $this->year . $this->month . $day;
        return $link;
    } 

    function getCell($day)
    {
        if ($day == $this->day) {
            if (!empty($this->content[intval($day)])) {
                $cell .= "<td align='center' class='bg3'><a href=\"" . $this->getLink($day) . "\" title=\"" . $this->content[intval($day)] . "\"><b>$day</b></a></td>";
            } else {
                $cell .= "<td align='center' class='bg1'><b>$day</b></td>";
            } 
        } else {
            if (!empty($this->content[intval($day)])) {
                $cell .= "<td align='center' class='bg3'><a href=\"" . $this->getLink($day) . "\" title=\"" . $this->content[intval($day)] . "\">$day</a></td>";
            } else {
                $cell .= "<td align='center' class='bg1'>$day</td>";
            } 
        } 

        return $cell;
    } 

    function setContent()
    {
        global $db;

        $monthstart = mktime(0 - $this->timeoffset, 0, 0, $this->month, 1, $this->year);
        $monthend = mktime(23 - $this->timeoffset, 59, 59, $this->month + 1, 0, $this->year);
        $monthend = ($monthend > time()) ? time() : $monthend;

        $this->setSeparator();

        $sql = "SELECT " . $this->time . "," . $this->title . " FROM " . $db->prefix($this->table) . " WHERE " . $this->time . " > " . $monthstart . " and " . $this->time . " < " . $monthend . " order by " . $this->time . " DESC";
        $result = $db->query($sql);
        while (list($published, $title) = $db->fetch_row($result)) {
            $day = date("j", str_replace('"', "", $published));
            if (empty($this->content[$day])) {
                $this->content[$day] = htmlspecialchars(stripslashes($title));
            } else {
                $this->content[$day] .= $this->separator . htmlspecialchars(stripslashes($title));
            } 
        } 
    } 

    function render($month = false, $year = false)
    {
        global $db;

        $this->setTimeoffset();
        $this->month = (!$month) ? date('m', $this->usertimevent) : $month;
        $this->year = (!$year) ? date('Y', $this->usertimevent) : $year;
        $this->day = date("d", $this->usertimevent);
        $this->setContent();

        $calendar = $this->getCalHeader();

        $day = 1;
        while ($day <= cal_days_in_month(1, $this->month, $this->year)) {
            $calendar .= "<tr>";
            for ($i = 1; $i <= 7; $i++) {
                if ($day <= cal_days_in_month(1, $this->month, $this->year)) {
                    $week = date('w', mktime(0, 0, 0, $this->month, $day, $this->year));
                    if ($week == 0) $week = 7;
                    if ($week == $i) {
                        $day = $this->addZero($day);
                        $this->month = $this->addZero($this->month);
                        $calendar .= $this->getCell($day);
                        $day++;
                    } else
                        $calendar .= "<td></td>";
                } 
            } 
            $calendar .= "</tr>";
        } 
        $calendar .= $this->getCalFooter();

        return $calendar;
    } 

    function setSeparator()
    {
        if (preg_match("/MSIE ([0-9]{1,2}\.[0-9]{1,2})/i", _HTTP_USER_AGENT)) {
            $this->separator = ",\n\r";
        } else {
            $this->separator = ', ';
        } 
    } 

    function addZero($value)
    {
        return strlen($value) <= 1 ? 0 . $value : $value;
    } 

    function setLinkDate()
    {
        $this->lastlinkdate = $this->getLastDate();
        $this->nextlinkdate = $this->getNextDate();
    } 

    function getNextDate()
    {
        if ($this->month == "12") {
            $month = 1;
            $year = $this->year + 1;
        } else {
            $month = $this->month + 1;
            $year = $this->year;
        } 

        return "&nbsp&nbsp&nbsp<A HREF=\"" . $this->getRequestLink($year, $this->addZero($month)) . "\">>>></a>";
    } 

    function getLastDate()
    {
        if ($this->month == "1") {
            $month = 12;
            $year = $this->year - 1;
        } else {
            $month = $this->month - 1;
            $year = $this->year;
        } 

        return "<A HREF=\"" . $this->getRequestLink($year, $this->addZero($month)) . "\"><<<</a>&nbsp&nbsp&nbsp";
    } 

    function getRequestLink($year, $month)
    {
        global $myts;
    	
    	if (!empty($_GET['my'])) {
            $pos = strpos(_REQUEST_URI, 'my=');
            $length = $pos + 9;
            $requestlink = substr(_REQUEST_URI, 0, $pos);
            return $myts->oopsHtmlSpecialChars($requestlink) . "my=" . $year . $month;
        } else {
            $separator .= (count($_GET) != 0)?"&":"?";
            return $myts->oopsHtmlSpecialChars(_REQUEST_URI) . $separator . "my=" . $year . $month;
        } 
    }  

    function getCalHeader()
    {
        $this->setLinkDate();

        return <<<END
<table width="100%" border="0" cellspacing="1" cellpadding="0">
    <tr class="bg2">
	<td valign="top">
	<table width="100%" border="0" cellspacing="1" cellpadding="4">
	    <tr align="center" class='bg3'>
		<td colspan='7'>{$this->lastlinkdate}{$this->monthname[intval($this->month)]} {$this->year}{$this->nextlinkdate}</td>
	    </tr>
	    <tr align="center" class='bg1'>
		<td>{$this->weekname[1]}</td>
		<td>{$this->weekname[2]}</td>
		<td>{$this->weekname[3]}</td>
		<td>{$this->weekname[4]}</td>
		<td>{$this->weekname[5]}</td>
		<td>{$this->weekname[6]}</td>
		<td>{$this->weekname[7]}</td>
	    </tr>
END;
    } 

    function getCalFooter()
    {
        return <<<END
</table></td></tr></table>
END;
    } 
} 

?>