<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 The Xoops Project. All rights reserved.
 * @link http://www.xoops.org 
 * @author Kazumi Ono <http://www.myweb.ne.jp>
 * @license GPL <http://www.gnu.org/licenses/gpl.html>
 */
defined('XOOPS_ROOT_PATH') or exit('<h1>Forbidden</h1> You don\'t have permission to access');

include_once(XOOPS_ROOT_PATH . "/class/xoopsform/formselect.php");

class ArtFormSelect extends XoopsFormSelect {
    var $disabled = false;

    function ArtFormSelect($caption, $name, $value = "", $size = 1, $multiple = false)
    {
        parent::XoopsFormSelect($caption, $name, $value, $size, $multiple);
    } 

    function setDisabled()
    {
        $this->disabled = true;
    } 

    function render()
    {
        $ret = "<select";

        if (!empty($this->disabled)) $ret .= " disabled";

        $ret .= " class='select' size='" . $this->getSize() . "'" . $this->getExtra() . "";

        if ($this->isMultiple() != false) {
            $ret .= " name='" . $this->getName() . "[]' id='" . $this->getName() . "[]' multiple='multiple'>";
        } else {
            $ret .= " name='" . $this->getName() . "' id='" . $this->getName() . "'>";
        } 

        foreach ($this->getOptions() as $value => $name) {
            $ret .= "<option value='" . htmlspecialchars($value, ENT_QUOTES) . "'";
            $count = count($this->getValue());
            if ($count > 0 && in_array($value, $this->getValue())) {
                $ret .= " selected='selected'";
            } 
            $ret .= ">" . $name . "</option>";
        } 
        $ret .= "</select>";

        return $ret;
    } 
    // ---------------------------------------------------------------------------------------//
} // END CLASS

?>
