<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

include_once("artobject.class.php");

class RatingArticles extends ArtObject {
	function RatingArticles($id = null)
	{
		parent::ArtObject();
		$this->initVar("ratingid", "int", null, false);
		$this->initVar("lid", "int", null, false);
		$this->initVar("ratinguser", "int", null, false);
		$this->initVar("rating", "other", null, false);
		$this->initVar("ratinghostname", "other", null, false);
		$this->initVar("ratingtimestamp", "int", null, false);
		$this->initVar("uname", "textbox", null, false, null, false);
		if (!empty($id)) {
			if (is_array($id)) {
				$this->set($id);
			} else {
				$this->load(intval($id));
			} 
		} 
	} 

	function store()
	{
		global $db;

		if ($this->checkVotes()) {
			return false;
		} 
		if (!$this->isCleaned()) {
			if (!$this->cleanVars()) {
				return false;
			} 
		} 
		foreach ($this->cleanVars as $k => $v) {
			$$k = $v;
		} 
		$ratingid = $db->genId($db->prefix("artvotedata") . "_rid_seq");
		$sql = "INSERT INTO " . $db->prefix("artvotedata") . " SET ratingid=$ratingid, lid=$lid, ratinguser=$ratinguser, rating=" . intval($rating) . ", ratinghostname='$ratinghostname', ratingtimestamp=" . time() . "";
		if (!$result = $db->query($sql)) {
			$this->setErrors(_NOTUPDATED);
			return false;
		} 
		if (empty($ratingid)) {
			$ratingid = $db->insert_id();
		} 
		$this->updateRating();
		return $ratingid;
	} 

	function checkVotes()
	{
		global $db;

		if ($this->getVar("rating") == 0) {
			$this->setErrors(_NW_NORATING);
			return true;
		} 

		if ($this->getVar("ratinguser")) {
			$sql = "SELECT COUNT(*) FROM " . $db->prefix("artstories") . " WHERE storyid=" . $this->getVar("lid") . "  AND uid=" . $this->getVar("ratinguser");
			list($count) = $db->fetch_row($db->query($sql));
			if ($count > 0) {
				$this->setErrors(_NW_CANTVOTEOWN);
				return true;
			} 

			$sql = "SELECT COUNT(*) FROM " . $db->prefix("artvotedata") . " WHERE lid=" . $this->getVar("lid") . " AND ratinguser=" . $this->getVar("ratinguser");
			list($count) = $db->fetch_row($db->query($sql));
			if ($count > 0) {
				$this->setErrors(_NW_VOTEONCE);
				return true;
			} 
		} else {
			$sql = "SELECT COUNT(*) FROM " . $db->prefix("artvotedata") . " WHERE lid=" . $this->getVar("lid") . " AND ratinghostname = '" . $this->getVar("ratinghostname") . "'";
			list($count) = $db->fetch_row($db->query($sql));
			if ($count > 0) {
				$this->setErrors(_NW_VOTEONCE);
				return true;
			} 
		} 
		return false;
	} 

	function updateRating()
	{
		global $db;

		$sql = "SELECT rating FROM " . $db->prefix("artvotedata") . " WHERE lid=" . $this->getVar("lid") . "";
		$result = $db->query($sql);
		$num_votes = intval($db->num_rows($result));
		if ($num_votes > 0) {
			$totalrating = 0;
			while (list($rating) = $db->fetch_row($result)) {
				$totalrating += intval($rating);
			} 
			$finalrating = ($totalrating / $num_votes);
			$finalrating = number_format($finalrating, 2);
		} else {
			$finalrating = 0;
		} 

		$sql = "UPDATE " . $db->prefix("artstories") . " SET rating=$finalrating, votes=$num_votes WHERE storyid = " . $this->getVar("lid");
		$db->query($sql) or print($db->error());
	} 

	function load($ratingid)
	{
		global $db;

		$sql = "SELECT * FROM " . $db->prefix("artvotedata") . " WHERE ratingid=" . intval($ratingid) . "";
		$myrow = $db->fetch_array($db->query($sql));
		$this->set($myrow);
	} 

	function delete()
	{
		global $db;

		$sql = "DELETE FROM " . $db->prefix("artvotedata") . " WHERE ratingid=" . $this->getVar("ratingid") . "";
		if (!$db->query($sql)) {
			return false;
		} 
		$this->updateRating();
		return true;
	} 

	function deleteByStoriesId($storyid)
	{
		global $db;

		$sql = "DELETE FROM " . $db->prefix("artvotedata") . " WHERE lid=" . intval($storyid);
		if (!$db->query($sql)) {
			return false;
		} 
		return true;
	} 

	function &getAllRatings($criteria = array(), $orderby = "ratingtimestamp DESC", $limit = 0, $start = 0)
	{
		global $db;

		$ret = array();
		$where_query = "";

		if (is_array($criteria) && count($criteria) > 0) {
			$where_query = " WHERE";
			foreach ($criteria as $c) {
				$where_query .= " v.$c AND";
			} 
			$where_query = substr($where_query, 0, -4);
		} 

		$sql = "SELECT v.*, u.uname 
		FROM " . $db->prefix("artvotedata") . " v 
		LEFT JOIN " . $db->prefix("users") . " u 
		ON u.uid=v.ratinguser" . $where_query . " ORDER BY v.$orderby";
		$result = $db->query($sql, intval($limit), intval($start));
		while ($myrow = $db->fetch_array($result)) {
			$ret[] = new RatingArticles($myrow);
		} 
		return $ret;
	} 

	function getTotalVotes()
	{
		global $db;

		$sql = "SELECT COUNT(*) FROM " . $db->prefix("artvotedata");
		list($votes) = $db->fetch_row($db->query($sql));
		return $votes;
	} 
} 

?>