<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

include_once("artobject.class.php");

class ArticlesSections extends ArtObject {
    var $logo_path;
    function ArticlesSections($id = null)
    {
        parent::ArtObject();
        $this->initVar("topic_id", "int", null, false);
        $this->initVar("topic_pid", "int", 0, false);
        $this->initVar("topic_title", "textbox", null, false, null, false);
        $this->initVar("topic_imgurl", "textbox", null, false, null, false);
        $this->initVar("topic_desc", "textarea", null, true, null, true);
        $this->initVar("items", "int", 0, false);

        if (!empty($id)) {
            if (is_array($id)) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            } 
        } 
    } 

    function store()
    {
        global $db;

        if (!$this->isCleaned()) {
            if (!$this->cleanVars()) {
                return false;
            } 
        } 
        foreach ($this->cleanVars as $k => $v) {
            $$k = $v;
        } 

        if (empty($topic_id)) {
            $topic_id = $db->genId($db->prefix("arttopics") . "_topic_id_seq");
            $sql = "INSERT INTO " . $db->prefix("arttopics") . " SET topic_id=$topic_id, topic_pid=$topic_pid, topic_title='$topic_title', topic_imgurl='$topic_imgurl', topic_desc='$topic_desc'";
        } else {
            $sql = "UPDATE " . $db->prefix("arttopics") . " SET topic_title='$topic_title', topic_imgurl='$topic_imgurl', topic_pid=$topic_pid, topic_desc='$topic_desc' WHERE topic_id=$topic_id";
        } 

        if (!$result = $db->query($sql)) {
            $this->setErrors(_NOTUPDATED);
            return false;
        } 
        if (empty($topic_id)) {
            $topic_id = $db->insert_id();
        } 
        return $topic_id;
    } 

    function load($topic_id)
    {
        global $db;

        $sql = "SELECT * FROM " . $db->prefix("arttopics") . " WHERE topic_id=" . intval($topic_id) . "";
        $myrow = $db->fetch_array($db->query($sql));
        $this->set($myrow);
    } 

    function delete()
    {
        global $db;

        include_once(XOOPS_ROOT_PATH . "/class/xoopstree.php");
        $mytree = new XoopsTree($db->prefix("arttopics"), "topic_id", "topic_pid");
        $sections = $mytree->getAllChild($this->getVar("topic_id"));

        foreach ($sections as $section) {
            if (!$this->_delete($section['topic_id'], $section['topic_imgurl'])) {
                return false;
            } 
        } 
        if (!$this->_delete($this->getVar("topic_id"), $this->getVar("topic_imgurl"))) {
            return false;
        } 
        return true;
    } 

    function _delete($topic_id, $imgurl)
    {
        global $db;

        $sql = "DELETE FROM " . $db->prefix("arttopics") . " WHERE topic_id=" . intval($topic_id) . "";
        if (!$db->query($sql)) {
            $this->setErrors("     " . basename($this->getVar("topic_title")) . "   ");
            return false;
        } 
		
        $this->_deleteArticlesInSection($topic_id);
		$this->_deleteSectionsLogo($imgurl);

        return true;
    } 

    function _deleteArticlesInSection($topic_id)
    {
        include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/articles.class.php');

        $articles = Articles::getAllArticles(array('topicid=' . intval($topic_id) . ''));
        foreach ($articles as $article) {
            $article->delete();
            array_merge($this->errors, $article->getErrors(false));
        } 
    } 

    function _deleteSectionsLogo($imgurl)
    {
        if ($imgurl != '') {
            $logo_path = $this->logo_path . basename($imgurl);
            if (!file_exists($logo_path)) {
                $this->setErrors("   " . basename($imgurl) . "   ");
            } 
            unlink($logo_path);
        } 
    } 

    function setLogoPath($logo_path)
    {
        $this->logo_path = $logo_path;
    } 

    function getSectionsLogo()
    {
        if ($this->_checkURL($this->getVar("topic_imgurl"))) {
            if (is_file(XOOPS_ROOT_PATH . '/modules/myarticles/cache/topics/' . $this->getVar("topic_imgurl"))) {
                return "<img src='" . formatURL(XOOPS_URL . '/modules/myarticles/cache/topics/', $this->getVar("topic_imgurl")) . "' border='0'>";
            } else {
                return $this->getVar("topic_imgurl");
            } 
        } 
    } 

    function _checkURL($url)
    {
        $url = trim($url);
        if ($url != '') {
            if (!preg_match("/^http[s]*:\/\//i", $url)) {
                return false;
            } 
        } 
        return true;
    } 
} 

?>