<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 The Xoops Project. All rights reserved.
 * @link http://www.ruscms.ru
 * @author The Xoops Project <http://www.xoops.org>
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 * @license GPL <http://www.gnu.org/licenses/gpl.html>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

include_once(XOOPS_ROOT_PATH . "/class/module.textsanitizer.php");

class ArtTextSanitizer extends MyTextSanitizer {
	function ArtTextSanitizer()
	{
		global $xoopsConfig;

		$this->setAllowImage($xoopsConfig['allow_image']);
		$this->setAllowLibrary($xoopsConfig['allow_library']);
	}

	function escapeTags($text, $type = 'user')
	{
		global $xoopsConfig;

		if ($type == 'admin') {
			$html_tags = $xoopsConfig['admin_html'];
		} else {
			$html_tags = $xoopsConfig['user_html'];
		}
		if (!empty($html_tags)) {
			$search = "/<(\/{1})?\b(?!($html_tags){1})\b(.*)>/siU";
			$replace = "&lt;\\1\\2\\3&gt;";
			$text = preg_replace($search, $replace, $text);
		}
		return $text;
	}

	function sanitizeWysiwygText($text, $allow_smileys=1, $allow_bbcode=1)
	{

		if ($allow_bbcode == 1) {
			$search  = "/\[code](.*)\[\/code\]/esU";
			$replace = "'[enc_code]'.base64_encode(stripslashes('\\1')).'[/enc_code]'";
			$text = preg_replace($search, $replace, $text);
		}
		$text = $this->escapeTags($text, $this->type);

		if ($this->clickable) $text = $this->makeClickable($text);
		if ($allow_smileys == 1) $text = $this->smiley($text);
		if ($allow_bbcode == 1) $text = $this->xoopsCodeDecode($text, 2);
	
		$this->setType('user');
		return $text;
	}
} // END ARTTEXTSANTISIZER

?>