<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined( 'XOOPS_ROOT_PATH' ) or exit( '<h1>Forbidden</h1> You don\'t have permission to access' );

include_once(XOOPS_ROOT_PATH . '/class/xoopstree.php');

class ArticlesTree extends XoopsTree {
    function ArticlesTree($table, $cid, $pid)
    {
        $this->XoopsTree($table, $cid, $pid);
    } 

    function getTreeTopics($pid = 0, $order = '', $parray = '', $r_prefix = '')
    {
        global $db, $myts, $cid_arr;
        static $bgcount;

        $sql = 'SELECT * FROM ' . $this->table . ' WHERE ' . $this->pid . '=' . $pid . '';

        if ($order != '') {
            $sql .= ' ORDER BY ' . $order . '';
        } 

        $result = $db->query($sql);
        $count = $db->num_rows($result);

        if ($count == 0) {
            return $parray;
        } 

        if ($pid == 0) $parray .= '<table width="100%" cellpadding=1 border=0 cellspacing=1 class="bg2"><tr><td><b>' . _NW_TOPIC . ':</b></td></tr><tr><td class="bg1">';

        while ($row = $db->fetch_array($result)) {
            $check = ($cid_arr)?in_array($row['topic_id'], $cid_arr):false;
            $bgcount ++;
            $color = ($pid == 0)? "bg2":(is_integer($bgcount / 2)?"bg1":"bg3");
            $row['prefix'] = ($pid == 0)?$r_prefix:$r_prefix . '&nbsp;&nbsp;&nbsp;&nbsp;';
            $parray .= '<table width="100%" cellpadding=4 border=0 cellspacing=0><tr class=' . $color . '>';
            $parray .= '<td>' . $row['prefix'] . '</td><td width="100%"><IMG SRC=\'' . XOOPS_URL . '/modules/myarticles/images/tree_close.gif\' BORDER=0 WIDTH=13 HEIGHT=12 >&nbsp;';
            if ($check) $parray .= '<A HREF=' . XOOPS_URL . '/modules/myarticles/topics.php?topic_id=' . $row['topic_id'] . '>';
            $parray .= $myts->makeTboxData4Show($row['topic_title']);
            if ($check) $parray .= '</A>';
            $parray .= '<BR>' . $row['topic_desc'] . '</td></tr></table>';
            $parray = $this->getTreeTopics($row['topic_id'], $order, $parray, $row['prefix']);
        } 
        if ($pid == 0) $parray .= '</td></tr></table>';
        return $parray;
    } 

    function getAllChildId($pid, $title = 'title', $idarray = array())
    {
        if (empty($this->pidcid)) {
            $this->loadtree($title);
        } 

        $ele = $this->pidcid[$pid];

        if (!empty($ele)) {
            foreach ($ele as $key => $value) {
                array_push($idarray, $key);
                $idarray = $this->getAllChildId($key, $title, $idarray);
            } 
        } 

        return $idarray;
    } 

    function getOptionSel($title, $order = '', $preset_id = 0)
    {
        global $db, $myts;

        $sql = 'SELECT ' . $this->cid . ', ' . $title . ' FROM ' . $this->table . ' WHERE ' . $this->pid . '=0';

        if ($order != '') {
            $sql .= ' ORDER BY ' . $order . '';
        } 

        $result = $db->query($sql);

        while (list($catid, $name) = $db->fetch_row($result)) {
            if ($catid == $preset_id) {
                $sel = ' selected="selected"';
            } 
            $options .= '<option value="' . $catid . '"' . $sel . '>' . $name . '</option>';
            $sel = '';
            $arr = $this->getChildTreeArray($catid, $title);
            foreach ($arr as $option) {
                $option['prefix'] = str_replace('.', '--', $option['prefix']);
                $catpath = $option['prefix'] . ' ' . $myts->makeTboxData4Show($option[$title]);
                if ($option[$this->cid] == $preset_id) {
                    $sel = ' selected="selected"';
                } 
                $options .= '<option value="' . $option[$this->cid] . '"' . $sel . '>' . $catpath . '</option>';
                $sel = '';
            } 
        } 
        return $options;
    } 

    function setArticlesInCategorys()
    {
        global $db;

        $result = $db->query("SELECT topicid FROM " . $db->prefix("artstories") . " WHERE published > 0 AND published <= " . time() . "");
        while ($myrow = $db->fetch_array($result)) {
            $this->cnt_arr[$myrow['topicid']]++;
        } 
    } 

    function showTreeForCp()
    {
        $this->setArticlesInCategorys();
        $this->loadtree('topic_title');
        unset($this->cidpid);
        echo $this->getTreeForCp();
        unset($this->pidcid);
    } 

    function getTreeForCp($pidcid = 0, $parray = '', $r_prefix = '')
    {
        global $xoopsModule;

        if ($pidcid == 0) $parray .= '<table width="100%" cellpadding=3 border=0 cellspacing=1 class="bg3"><tr  class="bg3"><td width="40%">' . _AM_TOPICS . '</td><td width="30%">' . _AM_TOTAL_ARTICLES . '</td><td width="30%">' . _ACTION . '</td></tr>';

        if ($this->pidcid[$pidcid]) {
            foreach($this->pidcid[$pidcid] as $k => $v) {
                $cnt = ($this->cnt_arr[$k]) ? '<b>' . $this->cnt_arr[$k] . '</b>' : '';
                $bgcount ++;
                $color = ($pidcid == 0)? "bg2":(is_integer($bgcount / 2)?"bg1":"bg3");
                $this->pidcid['prefix'] = ($pidcid == 0)?$r_prefix:$r_prefix . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp';
                $parray .= '<tr class=' . $color . '><td width="40%">';
                $parray .= $this->pidcid['prefix'];
                $parray .= '&nbsp;<A HREF=' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/admin/index.php?op=modTopic&pid=' . $k . ' title=\'' . _AM_ADDSUBTOPIC . '\'><IMG SRC=\'' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/images/plus.gif\' BORDER=0 WIDTH=10 HEIGHT=10></A>';
                $parray .= '<IMG SRC=\'' . XOOPS_URL . '/images/menu/d_tree_close.gif\' BORDER=0 WIDTH=26 HEIGHT=16 >&nbsp;';
                if ($cnt) $parray .= '<A HREF=' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/admin/index.php?op=artmanager&topic_id=' . $k . '>';
                $parray .= $v;
                if ($cnt) $parray .= '</A>';
                $parray .= '<BR></td>';
                $parray .= '<td width="30%">' . (($cnt)?$cnt:'---') . '</td>';
                $parray .= '<td width="30%"><A HREF=' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/admin/index.php?op=modTopic&topic_id=' . $k . '>' . _MODIFY . '</A> | ';
                $parray .= '<A HREF=' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/admin/index.php?op=delTopic&topic_id=' . $k . '>' . _DELETE . '</A>';
                $parray .= '</td></tr>';
                $parray = $this->getTreeForCp($k, $parray, $this->pidcid['prefix']);
            } 
        } else {
            return $parray;
        } 
        if ($pidcid == 0) $parray .= '</table>';
        return $parray;
    } 
} // END CLASS TREE
// ------------------------------------------------------------------------- //
?>