<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined('XOOPS_ROOT_PATH') or exit('<h1>Forbidden</h1> You don\'t have permission to access');

include_once(XOOPS_ROOT_PATH . '/class/xoopspagenav.php');
include_once(XOOPS_ROOT_PATH . "/class/xoopsform/formselect.php");

function art_manager($topic_id = 0, $page = 10, $start = 0, $sorting = 3, $direction = 2)
{
    global $db;

    if ($topic_id) {
        include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/sections.class.php');
        $sections = new ArticlesSections($topic_id);

        if ($sections->getVar("topic_id") == 0) {
            redirect_header("index.php?op=artmanager", 2, _AM_NO_TOPIC);
            exit();
        } 
        $link = '<b><a href="index.php?op=artmanager">' . _MI_ARTICLES_ADMENU3 . '</a>';
        $link .= "  &raquo; " . sprintf(_AM_MODIFY_ST, $sections->getVar("topic_title")) . "</b>";
    } else {
        $link = "<b>" . _MI_ARTICLES_ADMENU3 . "</b>";
    } 

    xoops_cp_header();
    OpenTable();
    admin_link($link);

    echo "<table width='100%' border='0' cellspacing='1' cellpadding='0'><tr class='bg2'>";
    echo "<td valign='top'><table width='100%' border='0' cellspacing='1' cellpadding='6'>";
    echo "<tr class='bg1'><td>" . _AM_TOPIC . "</td><td>" . _AM_ARTSINPAGE . "</td><td>" . _AM_SORTING . "</td><td>" . _AM_DIRECTION . "</td><td>" . _ACTION . "</td></tr><tr class='bg3'>";
    echo "<form name='form' action='./index.php' method='get'><td align='center'>";

    if (file_exists(XOOPS_ROOT_PATH . "/modules/myarticles/cache/treeselbox.php")) {
        echo makeTreeSelBox(file_get_contents(XOOPS_ROOT_PATH . "/modules/myarticles/cache/treeselbox.php"), "topic_id", 1, $topic_id);
    } else {
        include_once(XOOPS_ROOT_PATH . "/class/xoopstopic.php");
        $xt = new XoopsTopic($db->prefix("arttopics"));
        $xt->makeTopicSelBox(1, $topic_id, "topic_id");
    } 

    echo "</td><td align='center'>";
    $page_select = new XoopsFormSelect("", "page", $page);
    $page_select->addOptionArray(getPageArray());
    echo $page_select->render();
    echo "</td><td align='center'>";
    $sort_select = new XoopsFormSelect("", "sort", $sorting);
    $sort_select->addOptionArray(getSortingArray());
    echo $sort_select->render();
    echo "</td><td align='center'>";
    $direct_select = new XoopsFormSelect("", "direct", $direction);
    $direct_select->addOptionArray(getDirectionArray());
    echo $direct_select->render();
    echo "</td>";
    echo "<input type='hidden' name='op' value='artmanager' />";
    echo "<td align='center'><input type='submit' class='button' value='" . _GO . "' /></td></form></tr>";
    echo "</table></td></tr></table><br />";

    $criteria = array('published > 0', 'published <= ' . time());
    $orderby = getSorting($sorting) . " " . getDirection($direction);
    if ($topic_id) $criteria[] = 'topicid = ' . $topic_id;
    $storyarray = Articles::getAllArticles($criteria, $page, $start, $orderby);

    if (count($storyarray) > 0) {
        echo "<table width='100%' border='0' cellspacing='1' cellpadding='0'><tr class='bg2'>";
        echo "<td valign='top'><table width='100%' border='0' cellspacing='1' cellpadding='6'>";
        echo "<tr class='bg2'><td align='center'>" . _AM_STORYID . "</td>";
        echo "<td align='center'>" . _AM_TITLE . "</td><td align='center'>" . _AM_TOPIC . "</td>";
        echo "<td align='center'>" . _AM_POSTER . "</td>";
        echo "<td align='center'>" . _AM_PUBLISHED . "</td>";
        echo "<td align='center'>" . _ACTION . "</td></tr>";

        foreach ($storyarray as $eachstory) {
            $published = formatTimestamp($eachstory->getVar('published'));
            if ($altbg == 0) {
                echo "<tr align='right' class='bg1'>";
                $altbg = 1;
            } else {
                echo "<tr align='right' class='bg3'>";
                $altbg = 0;
            } 
            echo "<td align='center'><b>" . $eachstory->getVar('storyid') . "</b></td>";
            echo "<td align='left'><a href='" . XOOPS_URL . "/modules/myarticles/article.php?storyid=" . $eachstory->getVar('storyid') . "'>" . $eachstory->getVar('title') . "</a></td>";
            echo "<td align='center'>" . $eachstory->getVar('topic_title') . "</td>";
            echo "<td align='center'>" . $eachstory->uname() . "</td>";
            echo "<td align='center'>" . $published . "</td>";
            echo "<td align='center'><a href='index.php?op=edit&amp;storyid=" . $eachstory->getVar('storyid') . "'>" . _EDIT . "</a>-<a href='index.php?op=delete&amp;storyid=" . $eachstory->getVar('storyid') . "'>" . _DELETE . "</a></td>";
            echo "</tr>";
        } 
        echo "</table></td></tr></table><br />";

        $artcount = Articles::countByTopic($topic_id);
        $pagenav = new XoopsPageNav($artcount, $page, $start, "op=artmanager&amp;topic_id=" . $topic_id . "&amp;sort=" . $sorting . "&amp;direct=" . $direction . "&amp;page=" . $page . "&amp;start", "");
        echo '<div align="center">' . $pagenav->renderNav(4, 2) . '</div>';
    } else {
        OpenTable();
        echo '<center>' . _AM_NOSTORY . '</center>';
        CloseTable();
    } 

    CloseTable();
} 

function getSorting($sorting = 3)
{
    switch ($sorting) {
        case 1:
            return "title";
        case 2:
            return "topicid";
        case 3:
            return "published";
        case 4:
            return "storyid";
        case 5:
            return "uid";
    } 
} 

function getDirection($direction = 2)
{
    switch ($direction) {
        case 1:
            return "ASC";
        case 2:
            return "DESC";
    } 
} 

function getPageArray()
{
    for ($i = 5; $i <= 100; $i = $i + 5) $sel[$i] = $i;
    return $sel;
} 

function getSortingArray()
{
    return array(1 => _AM_INHEADLINE,
        2 => _AM_INSECTION,
        3 => _AM_INDATE,
        4 => _AM_INID,
        5 => _AM_INAUTHOR);
} 
function getDirectionArray()
{
    return array(1 => _AM_INUP,
        2 => _AM_INDOWN);
} 

?>
