<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined('XOOPS_ROOT_PATH') or exit('<h1>Forbidden</h1> You don\'t have permission to access');

function save_article()
{
    global $xoopsUser, $meta, $xoopsConfig, $db, $mytree;
    if (empty($_POST['storyid'])) {
        $story = new Articles();
        $is_published = $story->getVar('published');
        $story->setVar("uid", $xoopsUser->uid());
        if ($_POST['autodate']) {
            $pubdate = mktime($_POST['autohour'], $_POST['automin'], 0, $_POST['automonth'], $_POST['autoday'], $_POST['autoyear']);
            $offset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'];
            $pubdate = ($pubdate - ($offset * 3600));
            $story->setVar("published", $pubdate);
        } else {
            $story->setVar("published", time());
        } 
        $story->setVar("type", $_POST['type']);
        $story->setVar("hostname", _REMOTE_ADDR);
    } else {
        $story = new Articles($_POST['storyid']);
        $is_published = $story->getVar('published');
        if (!empty($_POST['autodate'])) {
            
			$autohour = intval($_POST['autohour']);
            $automin = intval($_POST['automin']);
            $automonth = intval($_POST['automonth']);
            $autoday = intval($_POST['autoday']);
            $autoyear = intval($_POST['autoyear']);

            $pubdate = mktime($autohour, $automin, 0, $automonth, $autoday, $autoyear);
            $offset = $xoopsUser->timezone();
            $offset = ($offset - $xoopsConfig['server_TZ']);
            $pubdate = ($pubdate - ($offset * 3600));
            $story->setVar("published", $pubdate);
        } elseif (($story->getVar('published') == 0) && ($_POST['approve'] == 1)) {
            $story->setVar("published", time());
            $isnew = 1;
        } else {
            if (!empty($_POST['movetotop'])) {
                $story->setVar("published", time());
            } 
        } 
    } 

    if (empty($_POST['approve'])) {
        $story->setVar("published", 0);
    } 
    $story->setVar("topicid", $_POST['topicid']);
    $story->setVar("title", $_POST['title']);
    $story->setVar("hometext", $_POST['hometext']);
    $story->setVar("bodytext", $_POST['bodytext']);
    $story->setVar("allow_html", $_POST['allow_html']);
    $story->setVar("allow_smileys", $_POST['allow_smileys']);
    $story->setVar("allow_bbcode", $_POST['allow_bbcode']);
    $story->setVar("ihome", $_POST['ihome']);
    $story->setVar("topicalign", $_POST['topicalign']);
    $story->setVar("topicdisplay", $_POST['topicdisplay']);
    $story->setVar("type", $_POST['type']);
    $story->setVar("use_wysiwyg", $_POST['use_wysiwyg']);

    if ($story->store()) {
        if (!empty($isnew) && $story->getVar('notifypub') && $story->getVar('uid') != 0) {
            send_mail_to_poster($story);
        } 
        inc_function('build_rss');

        if (!empty($_POST['protid'])) {
            if ($_POST['topicid'] != $_POST['protid']) {
                updatItems(intval($_POST['topicid']));
                updatItems(intval($_POST['protid']));
            } elseif ($is_published == 0) {
                updatItems(intval($_POST['topicid']));
            } 
        } else {
            updatItems(intval($_POST['topicid']));
        } 
        redirect_header("index.php?op=newarticle", 2, _UPDATED);
        exit();
    } else {
        echo $story->getErrors();
        exit();
    } 
} 

function send_mail_to_poster($story)
{
    global $xoopsConfig, $meta;
    $poster = new XoopsUser($story->getVar('uid'));
    $subject = _AM_ARTPUBLISHED;

    $xoopsMailer = &getMailer();
    $xoopsMailer->useMail();
    $xoopsMailer->setTemplateDir(XOOPS_ROOT_PATH . '/modules/myarticles/');
    $xoopsMailer->setTemplate('article_approve.tpl');
    $xoopsMailer->setToEmails($poster->getVar("email"));
    $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
    $xoopsMailer->setFromName($meta['title']);
    $xoopsMailer->setSubject($subject);

    $xoopsMailer->assign("UNAME", $poster->uname());
    $xoopsMailer->assign("STORY_NAME", $story->getVar('title'));
    $xoopsMailer->assign("STORY_URL", XOOPS_URL . "/modules/myarticles/article.php?storyid=" . $story->getVar('storyid'));
    $xoopsMailer->assign("PUBLISHED", formatTimestamp($story->getVar('published'), "m", 0));
    $xoopsMailer->assign("SITENAME", $meta['title']);
    $xoopsMailer->assign("SITEURL", XOOPS_URL);

    $xoopsMailer->send();
} 

?>
