<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 Ruscms.RU development group. All rights reserved.
 * @copyright (C) 2006 Vladislav Balnov (LARK) <balnov@kaluga.net>. All rights reserved.
 * @link http://www.ruscms.ru
 * @author Vladislav Balnov (LARK) <balnov@kaluga.net>
 */
defined('XOOPS_ROOT_PATH') or exit('<h1>Forbidden</h1> You don\'t have permission to access');

include_once(XOOPS_ROOT_PATH . '/class/xoopspagenav.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/tree.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/articles.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/sections.class.php');

function show_list_articles($topic_id)
{
    global $xoopsConfig, $xoopsUser, $db, $mytree, $myts, $meta, $artConfig;

    if (isset($_GET['st']) && is_numeric($_GET['st'])) {
        $start = intval($_GET['st']);
    } else {
        $start = 0;
    } 

    if (isset($_GET['ob']) && is_numeric($_GET['ob'])) {
        $ob = intval($_GET['ob']);
    } else {
        $ob = 6;
    } 

    if (isset($_GET['sn']) && is_numeric($_GET['sn'])) {
        $storynum = intval($_GET['sn']);
    } else {
        $storynum = $artConfig['storylist'];
    } 

    $orderby = getOrderby($ob);

    $sections = new ArticlesSections($topic_id);

    if ($sections->getVar("topic_id") == 0) {
        redirect_header("index.php", 2, _NW_NO_TOPIC);
        exit();
    } 

    include(XOOPS_ROOT_PATH . "/header.php");

    $criteria = array('published > 0', 'published <= ' . time(), 'topicid = ' . $topic_id);
    $articles = Articles::getAllArticles($criteria, $storynum, $start, $orderby, true);

    $artcount = Articles::countByTopic($topic_id);
    $pagenav = new XoopsPageNav($artcount, $storynum, $start, "topic_id=" . $topic_id . "&amp;ob=" . $ob . "&amp;sn=" . $storynum . "&amp;st", "");

    $mytree = new ArticlesTree($db->prefix("arttopics"), "topic_id", "topic_pid");

    $useroffset = "";
    if ($xoopsUser) {
        $timezone = $xoopsUser->timezone();
        if (isset($timezone)) {
            $useroffset = $xoopsUser->timezone();
        } else {
            $useroffset = $xoopsConfig['default_TZ'];
        } 
    } 
    OpenTable();

    $pathstring = "<A HREF='index.php'>" . _NW_PARENT . "</A> : ";
    $nicepath = $mytree->getNicePathFromId($topic_id, "topic_title", "topics.php?");
    unset($mytree->cidpid);
    $pathstring .= $nicepath;

    echo '<b>' . $pathstring . '</b> (' . $sections->getVar("items") . ')';

    if ($sections->getVar("topic_imgurl") || $sections->getVar("topic_desc")) {
        echo '<br><br><table cellpadding=2 border=0 cellspacing=1 >';
    } 
    if ($sections->getVar("topic_imgurl")) {
        echo "<tr><td rowspan='2'><img src=\"" . $xoopsConfig['xoops_url'] . "/modules/myarticles/cache/topics/" . $sections->getVar("topic_imgurl", "P") . "\" border=\"0\" alt=\"" . $sections->getVar("topic_title", "P") . "\">&nbsp;&nbsp;</td>";
    } 
    if ($sections->getVar("topic_desc")) {
        echo "<td><b>" . $sections->getVar("topic_title", "P") . "</b></td></tr><tr><td>" . $sections->getVar("topic_desc", "P") . "</td></tr>";
    } 
    if ($sections->getVar("topic_imgurl") || $sections->getVar("topic_desc")) {
        echo '</table>';
    } 
    if (count($mytree->pidcid[$topic_id]) > 0) {
        echo "<br><table cellpadding=2 border=0 cellspacing=0><tr><td><b>" . _NW_CATEGORIES . "</b></td></tr>";
        foreach ($mytree->pidcid[$topic_id] as $k => $v) {
            echo "<tr><td>&nbsp;&nbsp;<IMG SRC=" . XOOPS_URL . "/modules/myarticles/images/tree_close.gif BORDER=0 WIDTH=13 HEIGHT=12 ALIGN='absmiddle'>&nbsp;<a href='".rewrite_link("index.php?topic_id=" . $k) . "'>" . $v . "</a></td></tr>";
        } 
        echo '</table>';
    } 

    CloseTable();
    echo "<br>";

    unset($mytree->pidcid);
    if ($artcount != 0) {
        if ($artcount > 1) {
            echo getSortingBox($topic_id);
        } else {
            echo "<table width=\"100%\" cellpadding=2 border=0 cellspacing=1 class='bg2'><tr  class='bg3'><td >&nbsp;&nbsp;&nbsp;" . _NW_ARTICLES . "</td><td align=center >" . _NW_ACTIONS . "</td><td align=center>" . _NW_VIEWS . "</td><td  align=center>" . _NW_DATE . "</td></tr>";
        } 
        foreach ($articles as $article) {
            $printP = "<a href=\"" . rewrite_link($xoopsConfig['xoops_url'] . "/modules/myarticles/print.php?storyid=" . $article->getVar('storyid')) . "\"><img src=\"images/print.gif\" border=0 Alt=\"" . _NW_PRINTERFRIENDLY . "\" width=16 height=16></a>";
            $sendF = "<a target='_top' href='mailto:?subject=" . rawurlencode(sprintf(_NW_INTARTICLE, $meta['title'])) . "&body=" . rawurlencode(sprintf(_NW_INTARTFOUND, $meta['title'])) . ": \r\n " . $xoopsConfig['xoops_url'] . "/modules/myarticles/article.php?storyid=" . $article->getVar('storyid') . "'><img src=\"images/friend.gif\" border=0 Alt=\"" . _NW_SENDSTORY . "\" width=16 height=16></a>";
            $color = (is_integer($count / 2)) ? "bg1" : "bg3";

            echo "<TR class='$color'><td>&nbsp;&nbsp;&nbsp;<a href=\"" . rewrite_link($xoopsConfig['xoops_url'] . "/modules/myarticles/article.php?storyid=" . $article->getVar('storyid')) . "\">" . $article->getVar('title') . "</a></td><td align=center>$printP&nbsp;$sendF</td>
<td align=center>" . $article->getVar('counter') . "</td><td align=center>" . formatTimestamp($article->getVar('published'), "m", $useroffset) . "</td></tr>";

            $count ++;
        } 

        echo "</table>";
    } else {
        echo "<table width=\"100%\" height=\"50\" cellpadding=2 border=0 cellspacing=1 class='bg2'><tr class='bg3'><td><center>" . _MD_NOSTORY . "<center></td></tr>";
        echo "</table>";
    } 
    echo '<div align="center">' . $pagenav->renderNav(4, 2) . '</div>';

    inc_function('show_copyright');
    include ("../../footer.php");
    exit();
} 

function getOrderby($order = null)
{
    switch ($order) {
        case 1:
            return "title ASC";
        case 2:
            return "title DESC";
        case 3:
            return "counter ASC";
        case 4:
            return "counter DESC";
        case 5:
            return "published ASC";
        case 6:
            return "published DESC";
        default:
            return "title ASC";
    } 
} 

function getSortingBox($topic_id)
{
    return "<P><table width=\"100%\" cellpadding=2 border=0 cellspacing=1 class='bg2'><tr  class='bg3'><td >&nbsp;&nbsp;&nbsp;<a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=1")."'><img src='images/up.gif' border='0' align='middle' alt='' /></a>&nbsp;&nbsp;&nbsp;" . _NW_ARTICLES . "&nbsp;&nbsp;&nbsp;<a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=2")."'><img src='images/down.gif' border='0' align='middle' alt='' /></a></td><td align=center >" . _NW_ACTIONS . "</td><td align=center><a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=3")."'><img src='images/up.gif' border='0' align='middle' alt='' /></a>&nbsp;&nbsp;&nbsp;" . _NW_VIEWS . "&nbsp;&nbsp;&nbsp;<a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=4")."'><img src='images/down.gif' border='0' align='middle' alt='' /></a></td><td  align=center><a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=5")."'><img src='images/up.gif' border='0' align='middle' alt='' /></a>&nbsp;&nbsp;&nbsp;" . _NW_DATE . "&nbsp;&nbsp;&nbsp;<a href='".rewrite_link("topics.php?topic_id=$topic_id&ob=6")."'><img src='images/down.gif' border='0' align='middle' alt='' /></a></td></tr>";
} 

?>
