<?php 
// +-------------------------------------------------------------+
// | Russian Support RunCms                                      |
// +-------------------------------------------------------------+
// | Copyright (c) 2006 Ruscms.RU development group              |
// +-------------------------------------------------------------+
// | For the full copyright and license information please, view |
// | the license.txt file that was distributed with this source  |
// | code. If the license.txt file is missing, please visit the  |
// | RusCms homepage: http://www.ruscms.ru                       |
// +-------------------------------------------------------------+
/**
 * 
 * @version $Id$
 * @package modules
 * @copyright (C) 2006 The E-Xoops/RUNCMS Project <http://www.runcms.org> 
 * @link http://www.runcms.org
 * @author The E-Xoops/RUNCMS Project
 * @license GPL <http://www.gnu.org/licenses/gpl.html>
 */
include_once("header.php");
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/themes/theme.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/articles.class.php');
include_once(XOOPS_ROOT_PATH . "/modules/myarticles/include/functions.inc.php");
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/sections.class.php');
include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/textsanitizer.class.php');

$myts = new ArtTextSanitizer();

if ($xoopsUser) {
	$uid = $xoopsUser->uid();
} elseif ($artConfig['anonsubmit'] == 1) {
	$uid = 0;
} else {
	redirect_header("index.php", 3, _NW_ANONNOTALLOWED);
	exit();
}

$type = (_IS_ADMIN === 1) ? 'admin' : 'user';

switch ($_POST['op']) {
	case "preview":

		$sections = new ArticlesSections($_POST['topic_id']);
		include_once(XOOPS_ROOT_PATH . "/header.php");

		$subject = $_POST['subject'];
		$hometext = $_POST['hometext'];
		$moretext = $_POST['moretext'];
		$allow_html = intval($_POST['allow_html']);
		$allow_smileys = intval($_POST['allow_smileys']);
		$allow_bbcode = intval($_POST['allow_bbcode']);
		$noname = intval($_POST['noname']);
		$notifypub = intval($_POST['notifypub']);
		$topic_id = intval($_POST['topic_id']);

		$p_subject = $sections->getVar("topic_title", "P") . ": " . $myts->makeTboxData4Preview($subject);

		$myts->setType($type);

		$p_message = $myts->makeTareaData4Preview($hometext, $allow_html, $allow_smileys, $allow_bbcode);

		if (!empty($moretext)) {
			$myts->setType($type);
			$p_message .= "<br /><br />" . $myts->makeTareaData4Preview($moretext, $allow_html, $allow_smileys, $allow_bbcode);
		}

		$subject = $myts->makeTboxData4PreviewInForm($subject);

		if (checkGroups(userGroups(), $artConfig['wysiwyg_groups']) && $xoopsConfig['allow_html']) {
			$hometext = $myts->oopsStripSlashesGPC($hometext);
			$moretext = $myts->oopsStripSlashesGPC($moretext);
		}else {
			$hometext = $myts->makeTboxData4PreviewInForm($hometext);
			$moretext = $myts->makeTboxData4PreviewInForm($moretext);
		}


		art_preview($p_subject, $p_message);
		include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/storyform.inc.php');

		inc_function('show_copyright');
		include_once(XOOPS_ROOT_PATH . "/footer.php");
		break;

	case "post":

		$story = new Articles();

		$story->setVar("topicid", $_POST['topic_id']);
		$story->setVar("title", $_POST['subject']);
		if ($artConfig['WYSIWYGsubmit'] == 1 || $editorConfig["displayeditor"] == 1) {
			if (_IS_ADMIN === 1) {
				$myts->setAllowLibrary(1);
				$myts->setAllowImage(1);
			}
			$myts->setType($type);
			$hometext = $myts->sanitizeWysiwygText($_POST['hometext'], $_POST['allow_smileys'], $_POST['allow_bbcode']);
			$myts->setType($type);
			$moretext = $myts->sanitizeWysiwygText($_POST['moretext'], $_POST['allow_smileys'], $_POST['allow_bbcode']);
			$story->setVar('allow_smileys', 0);
			$story->setVar('allow_bbcode', 0);
			$story->setVar("allow_html", 2);
			$story->setVar("use_wysiwyg", 1);
		} else {
			$hometext = $_POST['hometext'];
			$moretext = $_POST['moretext'];
			$story->setVar("allow_smileys", $_POST['allow_smileys']);
			$story->setVar("allow_bbcode", $_POST['allow_bbcode']);
			$story->setVar("allow_html", $_POST['allow_html']);
		}
		$story->setVar("hometext", $hometext);
		$story->setVar("bodytext", $moretext);
		$story->setVar("uid", $uid);
		$story->setVar("hostname", _REMOTE_ADDR);
		$story->setVar("notifypub", $_POST['notifypub']);

		if (_IS_ADMIN === 1) {
			$story->setVar("type", "admin");
			$story->setVar("published", time());
		} elseif(checkGroups(userGroups(), $artConfig['wysiwyg_groups'])){
			$story->setVar("type", "admin");
			$story->setVar("published", 0);
		}else {
			$story->setVar("type", "user");
			$story->setVar("published", 0);
		}

		if ($story->store()) {
			if ($artConfig['notifysubmit'] == 1) {
				$xoopsMailer = &getMailer();
				$xoopsMailer->useMail();
				$xoopsMailer->setTemplateDir(XOOPS_ROOT_PATH . '/modules/myarticles/');
				$xoopsMailer->setTemplate('article_submit.tpl');
				$xoopsMailer->setToEmails($xoopsConfig['adminmail']);
				$xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
				$xoopsMailer->setFromName($meta['title']);
				$xoopsMailer->setSubject(_NW_NOTIFYSBJCT);

				if ($xoopsUser) {
					$poster = $xoopsUser->getVar("uname") . " <" . $xoopsUser->getVar("email") . ">";
				} else {
					$poster = $xoopsConfig['anonymous'];
				}
				$xoopsMailer->assign("POSTERNAME", $poster);
				$xoopsMailer->assign("STORY_NAME", $story->getVar('title'));
				$xoopsMailer->assign("CREATED", formatTimestamp(time(), "m", 0));
				$xoopsMailer->assign("SITENAME", $meta['title']);
				$xoopsMailer->assign("SITEURL", XOOPS_URL);

				$xoopsMailer->send();
			}
			if (_IS_ADMIN === 1) {
				include_once(XOOPS_ROOT_PATH . '/modules/myarticles/class/tree.class.php');
				$mytree = new ArticlesTree($db->prefix("arttopics"), "topic_id", "topic_pid");
				updatItems(intval($_POST['topic_id']));
			}
			redirect_header("index.php", 2, _NW_THANKS);
			exit();
		}else {
			redirect_header("index.php", 2, _NOTUPDATED."<br />".$story->getErrors());
			exit();
		}
		break;
	default:
		include_once(XOOPS_ROOT_PATH . "/header.php");
		OpenTable();
		if ($artConfig['show_disclaimer'] == 1) {
			$disclaimer = implode('', file("./cache/disclaimer.php"));
			$disclaimer = $myts->makeTareaData4Show($disclaimer, 1, 1, 1);
			art_rules(_AM_DISCLAIMER, $disclaimer);
		}

		$subject = '';
		$hometext = '';
		$moretext = '';
		$noname = 0;
		$allow_smileys = 1;
		$allow_bbcode = 1;
		$notifypub = 0;
		$allow_html = 1;
		$topic_id = 0;

		include_once(XOOPS_ROOT_PATH . '/modules/myarticles/include/storyform.inc.php');
		CloseTable();
		inc_function('show_copyright');
		include_once(XOOPS_ROOT_PATH . "/footer.php");
		break;
}

?>